<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (2)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="manuals-and-specifications">Manuals and specifications</h1>
    <p>
      This book is a <em>tutorial</em>. It aims to help you gradually learn the
      language. But once you’re familiar with the basics, you’ll need other
      sources.
    </p>
    <h2 id="specification">Specification</h2>
    <p>
      <a
        href="https://www.ecma-international.org/publications/standards/Ecma-262.htm"
        >The ECMA-262 specification</a
      >
      contains the most in-depth, detailed and formalized information about
      JavaScript. It defines the language.
    </p>
    <p>
      But being that formalized, it’s difficult to understand at first. So if
      you need the most trustworthy source of information about the language
      details, the specification is the right place. But it’s not for everyday
      use.
    </p>
    <p>
      A new specification version is released every year. In-between these
      releases, the latest specification draft is at
      <a href="https://tc39.es/ecma262/" class="uri">https://tc39.es/ecma262/</a
      >.
    </p>
    <p>
      To read about new bleeding-edge features, including those that are “almost
      standard” (so-called “stage 3”), see proposals at
      <a href="https://github.com/tc39/proposals" class="uri"
        >https://github.com/tc39/proposals</a
      >.
    </p>
    <p>
      Also, if you’re developing for the browser, then there are other
      specifications covered in the
      <a href="info:browser-environment">second part</a> of the tutorial.
    </p>
    <h2 id="manuals">Manuals</h2>
    <ul>
      <li>
        <p>
          <strong>MDN (Mozilla) JavaScript Reference</strong> is the main manual
          with examples and other information. It’s great to get in-depth
          information about individual language functions, methods etc.
        </p>
        <p>
          One can find it at
          <a
            href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference"
            class="uri"
            >https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference</a
          >.
        </p>
      </li>
    </ul>
    <p>
      Although, it’s often best to use an internet search instead. Just use “MDN
      [term]” in the query, e.g. <a
        href="https://google.com/search?q=MDN+parseInt"
        class="uri"
        >https://google.com/search?q=MDN+parseInt</a
      >
      to search for <code>parseInt</code> function.
    </p>
    <h2 id="compatibility-tables">Compatibility tables</h2>
    <p>
      JavaScript is a developing language, new features get added regularly.
    </p>
    <p>To see their support among browser-based and other engines, see:</p>
    <ul>
      <li>
        <a href="http://caniuse.com" class="uri">http://caniuse.com</a> -
        per-feature tables of support, e.g. to see which engines support modern
        cryptography functions:
        <a href="http://caniuse.com/#feat=cryptography" class="uri"
          >http://caniuse.com/#feat=cryptography</a
        >.
      </li>
      <li>
        <a href="https://kangax.github.io/compat-table" class="uri"
          >https://kangax.github.io/compat-table</a
        >
        - a table with language features and engines that support those or don’t
        support.
      </li>
    </ul>
    <p>
      All these resources are useful in real-life development, as they contain
      valuable information about language details, their support etc.
    </p>
    <p>
      Please remember them (or this page) for the cases when you need in-depth
      information about a particular feature.
    </p>
  </body>
</html>
